include \masm32\include\masm32rt.inc

MyProc	PROTO: DWORD, :DWORD

Externdef	MyLabelInProc:NEAR

.data
MyDword	dd 123
MyString	db "Ciao", 0
hw	db "Hello World at 1024 bytes", 0

.data?
AnyVar	dd ?

.code
start:	m2m AnyVar, MyDword			; m2m, mem to mem: push/pop macro
	jmp MyLabel
	nop
MyLabel:
	mov AnyVar, 12345678h
	invoke MyProc, offset MyString, MyDword
	print offset hw, 13, 10, 10
	; getkey
	invoke ExitProcess, 0			; aka exit (not to be confused with MasmBasic Exit)

MyProc proc ptrMyString, MyDwordArg
LOCAL MyLocVarA:DWORD, MyRect:RECT
LOCAL Loc4Bytes[4]:BYTE
  lea edx, Loc4Bytes
  mov MyLocVarA, 12345678h				; watch them change in 
  mov MyRect.left, 123h						; Olly's stack window
  mov MyRect.top, 456h						; in the lower right corner
  mov MyRect.right, 321h
  mov MyRect.bottom, 654h
  je MyLabelInProc
  inc eax
  jmp MyLabelInProc
  mov eax, ptrMyString
  sub eax, ecx
  mov ecx, MyDwordArg
MyLabelInProc::								; a double colon makes this label global
  ret
MyProc endp

end start

RichMasm options:
*** NOTE: to get symbols, use Olly 1.1.; version 2 will not show symbolic names ***
	int 3			; in RichMasm, any uncommented int 3 will launch Olly when hitting F6
OPT_Assembler	mlv615			; JWasm may be used, too
OPT_DebugA	/Zi 			; debug options for assembly; /Zd is not needed
OPT_Linker	linkv614			; Only this version of the linker creates symbols acceptable to Olly
OPT_DebugL	/debug 			; linker options for symbolic debugging (/debugtype:cv not needed)
OPT_DelTmp	0			; S: In Olly, above Address | Hex Dump | Ascii, double-click tmp_file.asm:xx
OxPT_NoWarn	LNK4254, multiple		; we ignore linker warnings found in this string, e.g. section a merged into b with different attributes
OxPT_WAIT	0			; wait until a key is pressed before closing the DOS box
OxPT_DebugL	/MERGE:.rdata=.text		; for shorter executables, when debugging is finished
OxPT_Olly	2			; opt_olly 2 launches \masm32\OllyDbg\ollydb2.exe
OPT_Tmp2Asm	1
